Attribute VB_Name = "mppModule1"
Option Explicit  ' Requires programmer to declare all variables
' Public Arguments available anywhere
Public NSta As Long
Public Ndays As Long

Public Function GEGInterp(x1, xa, x2, y1, y2)
' interpolate ya based on inputs
'Dim x1 As Double
'Dim x2 As Double
'Dim xa As Double
'Dim y1 As Double
'Dim y2 As Double
Dim ya As Double
ya = (y1 * ((xa - x2) / (x1 - x2))) + (y2 * ((xa - x1) / (x2 - x1)))
GEGInterp = ya
End Function
Sub ssort(Arr() As Double, lngcnt As Long)
'
' Purpose:
' Takes array Arr and sorts shell sort
' lngcnt  number of values in array
'
' Arguments
Dim stmp As Double
Dim lngJ As Long
Dim lngK As Long
Dim lngL As Long
Dim lngInc As Long
Dim lngc As Long
   lngc = lngcnt
   lngInc = 1
10 lngInc = 3 * lngInc + 1
   If (lngInc <= lngc) Then GoTo 10
20 lngInc = lngInc \ 3
   For lngJ = lngInc + 1 To lngc
    stmp = Arr(lngJ)
    lngK = lngJ
30  lngL = lngK - lngInc
    If (Arr(lngL) >= stmp) Then
     Arr(lngK) = Arr(lngL)
     lngK = lngK - lngInc
     If (lngK <= lngInc) Then GoTo 40
     GoTo 30
    End If
40    Arr(lngK) = stmp
   Next lngJ
   If (lngInc > 1) Then GoTo 20
End Sub

Public Function GetPP(sis, ary, isize) As Double
' get plotting position of sorted array
' sis current index
' ary current array
' isize array size
Dim ppfi As Long
Dim pps As Double
ppfi = Int(sis)
If (sis = ppfi) Then  'integer result
 pps = ary(ppfi)
Else  'interpolate answer
 If (sis < 1#) Then
  pps = GEGInterp(0, sis, 1, 0, ary(1))
 ElseIf (sis > Ndays) Then ' if larger don't print for small arrays
  pps = -9999#
 Else 'interpolate
  pps = GEGInterp(ppfi, sis, ppfi + 1, ary(ppfi), ary(ppfi + 1))
 End If
End If
 GetPP = pps
End Function
Public Function GEGMED(indata, cont As Long) As Double
'take sorted array and array size find median
Dim scount As Double
Dim stmp As Double
Dim half As Long
Dim shalf As Double
Dim fi As Long
Dim fj As Long
Dim fk As Long
Dim fin As Long
fj = cont Mod 2 'modulus provides remainder
fk = cont \ 2 'integer division truncates
' get median value
If (fj = 0) Then  'this is an even number
 GEGMED = (indata(fk) + indata(fk + 1)) / 2
Else 'this is an odd number
 GEGMED = indata(fk + 1)
End If
End Function

Public Function INVCDF(pct As Double) As Double
'
' Purpose:
' To take probability 0-1 and calculate inverse cdf Z value
'
' History:
' Version 1.0 July 2005 by G.E. Granato
' pct input probability 0-1 values
'
' Equation 26.2.23. ABRAMOWITZ & STEGUN, NBS HANDBOOK OF MATHEMATICAL FUNCTIONS
'
' NOTE accounts for zero based arrays
' Arguments
Dim sw As Double
Dim swsign
If (pct) < 0 Then
 INVCDF = -6#
 Exit Function
ElseIf pct > 1# Then
 INVCDF = 6#
 Exit Function
ElseIf (pct) = 0 Then
 INVCDF = -3.9
 Exit Function
ElseIf pct = 1# Then
 INVCDF = 3.9
 Exit Function
ElseIf pct = 0.5 Then
 INVCDF = 0#
 Exit Function
ElseIf pct < 0.5 Then
 sw = (Log(1 / (pct * pct))) ^ 0.5
 swsign = -1#
Else
 sw = (Log(1 / ((1# - pct) * (1# - pct)))) ^ 0.5
 swsign = 1#
End If
INVCDF = swsign * (sw - (2.515517 + 0.802853 * sw + 0.010328 * sw * sw) / (1# + 1.432788 * sw + 0.189269 * sw * sw + 0.001308 * sw * sw * sw))
End Function


Public Function GEGDecileSkew(intMyType As Long, intMyDirection As Long, inQ, dMyA As Double, lngNumRec As Long) As Double
'
' Purpose:decile skew Helsel and Hirsch 2002 eq 1.12
'
' History:
' Version 1.0 April 2007 by G.E. Granato
'
'
'
' NOTE accounts for zero based arrays
' Arguments
' intMyType As long 1= linear 2 = ln 3 =log10
' intMyDirection As long sort direction 0 = ascending  1 desending
' inQ As Double array of values
' dMyA As Double plotting position a
' lngNumRec As Long number of records
' Variables
Dim dQ90 As Double
Dim dQ10 As Double
Dim dQ50 As Double
Dim dDecileSkew As Double
Dim lngp10 As Long
Dim lngP90 As Long

  On Error GoTo GEGDecileSkew:
   
' if less than 5 skew=0 exit
  If lngNumRec < 5 Then
   GEGDecileSkew = 0#
   Exit Function
  End If

' Get index for 90 and 10
  If intMyDirection = 0 Then
   lngp10 = CLng(((0.1 * Ndays) + (0.1) - (2 * dMyA * 0.1) + dMyA))
   lngP90 = CLng(((0.9 * Ndays) + (0.9) - (2 * dMyA * 0.9) + dMyA))
  Else
   lngP90 = CLng(((0.1 * Ndays) + (0.1) - (2 * dMyA * 0.1) + dMyA))
   lngp10 = CLng(((0.9 * Ndays) + (0.9) - (2 * dMyA * 0.9) + dMyA))
  End If
' adjust inQ for type
     dQ90 = (inQ(lngP90))
     dQ50 = GEGMED(inQ, lngNumRec)
     dQ10 = (inQ(lngp10))
   If intMyType = 1 Then ' adjust for ln of input values
     dQ90 = Log(dQ90)
     dQ50 = Log(dQ50)
     dQ10 = Log(dQ10)
   ElseIf intMyType = 2 Then ' use use log10 of input values
     dQ90 = Log(dQ90) / Log(10#)
     dQ50 = Log(dQ50) / Log(10#)
     dQ10 = Log(dQ10) / Log(10#)
   End If

   ' decile skew
     dDecileSkew = (((dQ90 - dQ50) - (dQ50 - dQ10)) / (dQ90 - dQ10))

   GEGDecileSkew = dDecileSkew

 Exit Function
GEGDecileSkew:
   GEGDecileSkew = 0#
   Exit Function
End Function


